/// <reference types="react" />
export declare const DivisionMenu = "division";
export interface PHeader {
    logo: string;
    user: {
        name: string;
        image?: string;
        sub?: string | JSX.Element;
        role?: string | JSX.Element;
    } | any;
    menuUserBar?: {
        title: string | JSX.Element;
        route: string;
    }[];
    menu: ({
        title: string | JSX.Element;
        route: string;
        titleCategory?: boolean;
        opened?: boolean;
        subMenu?: {
            title: string | JSX.Element;
            route: string;
        }[];
    } | 'division')[];
    myAccountRoute?: string;
    actionsElements?: JSX.Element;
    homeLink?: string;
    contentBeforeUser?: JSX.Element;
    __openUserMenuInfo?: boolean;
    __menuMobileOpen?: boolean;
}
export interface PHeaderChild extends PHeader {
    openUserMenuInfo: boolean;
    menuMobile: boolean;
    closeUserMenuInfo: () => any;
    toggleUserMenuInfo: () => any;
    toggleMenuMobile: () => any;
}
export interface SHeader {
    openUserMenuInfo: boolean;
    menuOpen: boolean;
}
//# sourceMappingURL=HeaderVertical.interface.d.ts.map