"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HeaderContainer = void 0;
var react_1 = __importStar(require("react"));
var Button_1 = require("../../Button");
var Tabs_1 = require("../../Tabs");
var PageListingContext_1 = require("../PageListingContext");
var S = __importStar(require("./HeaderContainer.style"));
function HeaderContainer() {
    var context = (0, react_1.useContext)(PageListingContext_1.PageListingContext);
    return react_1.default.createElement(HeaderMainComponent, __assign({}, context));
}
exports.HeaderContainer = HeaderContainer;
var HeaderMainComponent = function FiltersComponent(props) {
    return null;
};
var HeaderComponent = function FiltersDesktop(props) {
    var title = props.title, tabs = props.tabs;
    return (react_1.default.createElement(S.HeaderContainerStyle, { showIn: "desktop" },
        react_1.default.createElement("div", { className: "page-listing-title" },
            react_1.default.createElement("div", { className: "d-flex" },
                react_1.default.createElement("div", { className: "flex-fill align-self-center" },
                    react_1.default.createElement("h1", null, title)),
                react_1.default.createElement("div", { className: "text-right align-self-center" },
                    react_1.default.createElement(Button_1.Button, { onClick: function () { } }, "Adicionar")))),
        tabs && (react_1.default.createElement("div", { className: "header-listing-tabs-container" },
            react_1.default.createElement(Tabs_1.Tabs, __assign({}, tabs))))));
};
//# sourceMappingURL=HeaderContainer.js.map