/// <reference types="react" />
export interface IItemsToast {
    id?: string | number;
    message: string | JSX.Element;
    type?: 'danger' | 'error' | 'warning' | 'success';
    duration?: any;
}
export interface IItemToastListStore {
    id: string | number;
    message: string | JSX.Element;
    type?: 'danger' | 'error' | 'warning' | 'success';
    duration?: any;
    opened?: boolean;
    timeout: any;
}
export interface INewToast {
    id?: string | number;
    message: string | JSX.Element;
    type?: 'danger' | 'error' | 'warning' | 'success';
    duration?: any;
}
export interface IToastProps {
    id?: number;
    item?: IItemsToast;
    onDelete?: any;
}
//# sourceMappingURL=PageModal.interface.d.ts.map