"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SliderFullscreen = void 0;
var react_1 = __importDefault(require("react"));
var CloseBtn_1 = require("../CloseBtn");
var Modal_1 = require("../Modal");
var Slider_1 = require("../Slider");
var S = __importStar(require("./SliderFullscreen.style"));
var SliderFullscreen = function SliderFullscreen(props) {
    var _a = props.visible, visible = _a === void 0 ? false : _a, onRequestClose = props.onRequestClose, rest = __rest(props, ["visible", "onRequestClose"]);
    return (react_1.default.createElement(Modal_1.Modal, { show: visible, onRequestClose: onRequestClose },
        react_1.default.createElement(S.Container, null,
            react_1.default.createElement("div", { className: "close-icon-float" },
                react_1.default.createElement(CloseBtn_1.CloseBtn, { color: "white", onClick: onRequestClose }))),
        react_1.default.createElement(Slider_1.Slider, __assign({}, rest, { bgColor: "transparent", height: "90%", width: "100%" }))));
};
exports.SliderFullscreen = SliderFullscreen;
//# sourceMappingURL=SliderFullscreen.js.map