"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FormStyle = void 0;
var styled_components_1 = __importDefault(require("styled-components"));
var GetThemeVar_1 = require("../../support/GetThemeVar");
var css = styled_components_1.default.div;
exports.FormStyle = css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n   .input-title {\n      font-weight: 600;\n      text-transform: uppercase;\n      padding-bottom: 3px;\n      font-size: 12px;\n      color: rgba(0, 0, 0, 0.8);\n      transition: 0.2s all;\n\n      &.focus {\n         color: ", ";\n         transition: 0.2s all;\n      }\n   }\n\n   .input-border {\n      display: flex;\n      align-content: center;\n      align-items: center;\n      width: 100%;\n      background: white;\n      border: 2px solid rgba(0, 0, 0, 0.25);\n      border-radius: 3px;\n      color: #444;\n      font-size: 15px;\n      font-weight: 600;\n      height: 40px;\n      transition: 0.2s all;\n\n      ", "\n\n      .prefix {\n         flex: 0;\n         vertical-align: middle;\n         height: 100%;\n         padding-left: 10px;\n         font-size: 14px;\n         align-items: center;\n         justify-content: center;\n         display: flex;\n      }\n\n      .suffix {\n         flex: 0;\n         vertical-align: middle;\n         height: 100%;\n         padding-right: 10px;\n         font-size: 14px;\n         align-items: center;\n         justify-content: center;\n         display: flex;\n      }\n\n      &.has-error {\n         border-color: ", " !important;\n      }\n\n      input {\n         padding: 7px 10px;\n         width: 100%;\n         border: none;\n         flex: 1;\n         background: transparent;\n         font-size: 14px;\n         font-weight: 500;\n      }\n\n      .prefix ~ input {\n         padding-left: 10px;\n      }\n\n      &.text-right {\n         input {\n            text-align: right;\n         }\n      }\n\n      &.input-hidden {\n         border: none;\n      }\n\n      &.focus {\n         transition: 0.2s all;\n         border-color: ", ";\n      }\n   }\n\n   .error-input {\n      color: ", ";\n      text-align: left;\n      font-weight: 600;\n      margin: 0px;\n      padding: 0px;\n      font-size: 13px;\n      margin-top: 4px;\n      margin-bottom: 10px;\n   }\n\n   &.hide {\n      display: none;\n   }\n"], ["\n   .input-title {\n      font-weight: 600;\n      text-transform: uppercase;\n      padding-bottom: 3px;\n      font-size: 12px;\n      color: rgba(0, 0, 0, 0.8);\n      transition: 0.2s all;\n\n      &.focus {\n         color: ", ";\n         transition: 0.2s all;\n      }\n   }\n\n   .input-border {\n      display: flex;\n      align-content: center;\n      align-items: center;\n      width: 100%;\n      background: white;\n      border: 2px solid rgba(0, 0, 0, 0.25);\n      border-radius: 3px;\n      color: #444;\n      font-size: 15px;\n      font-weight: 600;\n      height: 40px;\n      transition: 0.2s all;\n\n      ", "\n\n      .prefix {\n         flex: 0;\n         vertical-align: middle;\n         height: 100%;\n         padding-left: 10px;\n         font-size: 14px;\n         align-items: center;\n         justify-content: center;\n         display: flex;\n      }\n\n      .suffix {\n         flex: 0;\n         vertical-align: middle;\n         height: 100%;\n         padding-right: 10px;\n         font-size: 14px;\n         align-items: center;\n         justify-content: center;\n         display: flex;\n      }\n\n      &.has-error {\n         border-color: ", " !important;\n      }\n\n      input {\n         padding: 7px 10px;\n         width: 100%;\n         border: none;\n         flex: 1;\n         background: transparent;\n         font-size: 14px;\n         font-weight: 500;\n      }\n\n      .prefix ~ input {\n         padding-left: 10px;\n      }\n\n      &.text-right {\n         input {\n            text-align: right;\n         }\n      }\n\n      &.input-hidden {\n         border: none;\n      }\n\n      &.focus {\n         transition: 0.2s all;\n         border-color: ", ";\n      }\n   }\n\n   .error-input {\n      color: ", ";\n      text-align: left;\n      font-weight: 600;\n      margin: 0px;\n      padding: 0px;\n      font-size: 13px;\n      margin-top: 4px;\n      margin-bottom: 10px;\n   }\n\n   &.hide {\n      display: none;\n   }\n"])), function (props) { return (0, GetThemeVar_1.GetThemeVar)(props.theme, 'primary'); }, function (props) {
    return props.themeInput === 'gray' &&
        "background: #eee;\n            border-color: #eee;\n        ";
}, function (props) { return (0, GetThemeVar_1.GetThemeVar)(props.theme, 'red'); }, function (props) { return (0, GetThemeVar_1.GetThemeVar)(props.theme, 'primary'); }, function (props) { return (0, GetThemeVar_1.GetThemeVar)(props.theme, 'red'); });
var templateObject_1;
//# sourceMappingURL=FormStyle.js.map