/// <reference types="react" />
export interface IItemsAlertBtn {
    text: string;
    color?: string;
    bgColor?: string;
    onPress?: () => void;
    style?: 'default' | 'cancel';
}
export interface IItemsAlert {
    title: string | JSX.Element;
    icon?: JSX.Element | any;
    iconColor?: string;
    titleColor?: string;
    message?: string | JSX.Element;
    onClose?: () => void;
    buttons: IItemsAlertBtn[];
}
//# sourceMappingURL=Alert.interface.d.ts.map