"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ModalPage = void 0;
var react_1 = __importStar(require("react"));
var CloseBtn_1 = require("../CloseBtn");
var Modal_1 = require("../Modal");
var S = __importStar(require("./ModalPage.style"));
exports.ModalPage = function ModalPage(props) {
    var children = props.children, show = props.show, title = props.title, _a = props.pageView, pageView = _a === void 0 ? false : _a, onRequestClose = props.onRequestClose, _b = props.animation, animation = _b === void 0 ? 'fade' : _b, _c = props.width, width = _c === void 0 ? 500 : _c, _d = props.height, height = _d === void 0 ? 0 : _d, _e = props.transparent, transparent = _e === void 0 ? false : _e, rest = __rest(props, ["children", "show", "title", "pageView", "onRequestClose", "animation", "width", "height", "transparent"]);
    var ContainerProps = (0, react_1.useMemo)(function () {
        return pageView
            ? {}
            : {
                show: show,
                onRequestClose: onRequestClose,
            };
    }, [pageView, onRequestClose, show]);
    var Container = (0, react_1.useMemo)(function () { return (pageView ? 'div' : Modal_1.Modal); }, [pageView]);
    return (react_1.default.createElement(Container, __assign({}, ContainerProps),
        react_1.default.createElement(S.Container, { width: width, height: height, className: "modal-page-container", pageView: pageView },
            !!title && (react_1.default.createElement("div", { className: "title-container" },
                react_1.default.createElement("div", { className: "title-name" }, title),
                !pageView && (react_1.default.createElement("div", { className: "float-right" },
                    react_1.default.createElement(CloseBtn_1.CloseBtn, { onClick: onRequestClose, size: 16 }))))),
            children)));
};
exports.ModalPage.Body = function ModalPageBody(props) {
    var children = props.children, rest = __rest(props, ["children"]);
    return react_1.default.createElement("div", { className: "body-container" }, children);
};
exports.ModalPage.Actions = function ModalPageBody(props) {
    var children = props.children, rest = __rest(props, ["children"]);
    return react_1.default.createElement("div", { className: "actions-container" }, children);
};
//# sourceMappingURL=ModalPage.js.map